<?php
/* SUDOKU PHP module: file "GenerateurSudoku-en_1.php"
+------------------------------------------------------------------------------+
| Tedheu 2010 (from the version: TT 19 september 19 2006)                      |
| Updated the january 24 2010                                                  |
| Sudoku puzzles synthesis, version 1 (en)                                     |
| provide data grid as JavaScript variables: result, Grille(9x9) ,Masque(9x9)  |
| Use this file as an external JavaScript module :   (like that)               |
| <SCRIPT language="JavaScript" src="http://..../modulesudoku.php"><\/SCRIPT>  |
+------------------------------------------------------------------------------+
*/
//
/*========= Variables ========================================================*/
// SuDoku grid, digits from "1" to "9", cell $i,$j
$Grille = array();
// mask grid: 0 = the cell shall be on, 1 = the cell can be blanked
$Masque = array();
// lottery as a list of couples 'letter/number' to chose a cell by drawing lots
$loterie = "";
// variable to check if a box was drawn more than one time
$collision = 0; 
// the grid are divided into 9 houses (Reg), and 9 Rows (Lgn), 9 columns (Col)
// Arrays $Reg,$Lgn,$Col using two indexes 'number,digit' ($n,$m m='digit-1')
// the stored values are a string giving the possible positions of the digit
$Reg = array();
$Lgn = array();
$Col = array();
//
/*========= computation loop  ================================================*/
$tentative = 0;
$tentative_max = 10;
initialisation();
while (strlen($loterie)>0 AND $tentative<$tentative_max){
$tentative++;
initialisation();
$iter = 0;
$itermax = 82;
while ($loterie<>"" AND $iter<$itermax){
  $iter++;
  // deterministic cell assignment with a digit
  $bingo = 0;
  for ($n=0; $n<=8; $n++){
    for ($m=0; $m<=8; $m++){
      // in first, the houses ($Reg)
      if (strlen($Reg[$n][$m])== 1){
        $p = ord($Reg[$n][$m])-48;
        $i = floor($n/3)*3+floor($p/3);
        $j = ($n-floor($n/3)*3)*3+($p-floor($p/3)*3);
        affectation($i,$j,$m,"1");
        $bingo = 1;
        break;
      }
      // in second, the rows ($Lgn)
      if (strlen($Lgn[$n][$m])== 1){
        $p = ord($Lgn[$n][$m])-48;
        $i = $n;
        $j = $p;
        affectation($i,$j,$m,"1");
        $bingo = 1;
        break;
      }
      // in third, the columns ($Col)
      if (strlen($Col[$n][$m])== 1){
        $p = ord($Col[$n][$m])-48;
        $i = $p;
        $j = $n;
        affectation($i,$j,$m,"1");
        $bingo = 1;
        break;
      }
    }
    if ($bingo== 1) break;
  }
  // cell assignment by drawing lots, if the deterministic assignment failed
  if ($bingo== 0){
    // choice of a cell $i,$j among the remainig free cells
    $ncase2 = strlen($loterie);
    $ncase = strlen($loterie)/2;
    $index = rand(0,$ncase-1)*2;
    $posi = substr($loterie,$index,2);
    // cell coordinates calculation: $i,$j
    $i = ord(substr($posi,0))-97;
    $j = ord(substr($posi,1))-48;
    // a digit is chosen by drawing lots among the remaining possibilities
    $liste = "";
    for ($m=0; $m<=8; $m++){
      $libre = 1;
      // houses
      $n = floor($i/3)*3+floor($j/3);
      if ($Reg[$n][$m]== "") $libre = 0;
      // rows
      $n = $i;
      if ($Lgn[$n][$m]== "") $libre = 0;
      // columns
      $n = $j;
      if ($Col[$n][$m]== "") $libre = 0;
      // result
      if ($libre== 1) $liste = $liste.chr(48+$m);
    }
    if (strlen($liste)>0){
      $m = ord(substr($liste,floor(rand(0,strlen($liste)-1))))-48;
      affectation($i,$j,$m,"0");
    }
  }
}
}
//
/*========= JavaScript outputs ===============================================*/
if (strlen($loterie)== 0){
  // a good filled grid is found
  $result= 'niveau_1';
  // $Grille[$i][$j] $i and $j from 0 to 8
  // $Masque[$i][$j], if =1 the digit can be hided, si =0 shall be displayed
  if ($tentative== 1){
    // a valid grid found from the first attempt
  }
  else{
    // a valid grid found after '$tentative' attempts
  }
}
else{
  // failure, no valid grid found
  $result= 'non';
}
print("result_sudoku= '".$result."';\n");
for ($i=0; $i<9; $i++){
  for ($j=0;$j<9; $j++){
  print("Grille_sudoku[".$i."][".$j."]= '".$Grille[$i][$j]."';\n");
  print("Masque_sudoku[".$i."][".$j."]= '".$Masque[$i][$j]."';\n");
  }
}
/*============================================================================*/
/*--------- Functions --------------------------------------------------------*/
function initialisation(){
  global $Grille ,$Masque ,$loterie ,$collision;
  global $Reg, $Lgn, $Col;
  $loterie = "";
  $collision = 0;
  // initialization, grid and mask, first to '0'
  for ($i=0; $i<=8; $i++){
    for ($j=0; $j<=8; $j++){
      $Grille[$i][$j] = "0";
      $Masque[$i][$j] = 0;
      $loterie = $loterie.chr(97+$i).chr(48+$j);
    }
  }
  // at beginning, the all positions are available
  for ($n=0; $n<=8; $n++){
    for ($m=0; $m<=8; $m++){
      $Reg[$n][$m] = "012345678";
      $Lgn[$n][$m] = "012345678";
      $Col[$n][$m] = "012345678";
    }
  }
}
//
function elimination($i,$j,$m){
  global $Grille ,$Masque ,$loterie ,$collision;
  global $Reg, $Lgn, $Col;
  // cell $i,$j , digit= $m+1
  // the digit is striked out by setting the possible positions to noting (= "")
  $n = floor($i/3)*3+floor($j/3); // concerned house, number $n
  $Reg[$n][$m] = "";
  $n = $i; // concerned row, number $n
  $Lgn[$n][$m] = "";
  $n = $j; // concerned column, number $n
  $Col[$n][$m] = "";
  // selective elimination of the possible positions in surrounded houses
  for($n=0; $n<=8; $n++){
    for ($p=0; $p<=8; $p++){
      // $p is the position of a cell in a house
      // $ic,$jc is the coordinates of the same cell in the grid
      $ic = floor($n/3)*3+floor($p/3);
      $jc = ($n-floor($n/3)*3)*3+($p-floor($p/3)*3);
      if ($ic==$i OR $jc==$j){
        $posi = Chr(48+$p);
        $Reg[$n][$m] = str_replace($posi,"",$Reg[$n][$m]);
      }
    }
  }
  // selective elimination of possible positions in surrounded rows
  $posi = chr(48+$j);
  for($n=0; $n<=8; $n++){
    $Lgn[$n][$m] = str_replace($posi,"",$Lgn[$n][$m]);
  }
  // selective elimination of possible positions in surrounded columns
  $posi = chr(48+$i);
  for($n=0; $n<=8; $n++){
    $Col[$n][$m] = str_replace($posi,"",$Col[$n][$m]);
  }
  // selective elimination of possible positions, rows-columns/house
  $n = floor($i/3)*3+floor($j/3); // concerned house, number $n
  for($p=0; $p<=8; $p++){
    // cell position with grid coordinates: $ic,$jc
    $ic = floor($n/3)*3+floor($p/3);
    $jc = ($n-floor($n/3)*3)*3+($p-floor($p/3)*3);
    $posi = chr(48+$jc);
    $Lgn[$ic][$m] = str_replace($posi,"",$Lgn[$ic][$m]);
    $posi = chr(48+$ic);
    $Col[$jc][$m] = str_replace($posi,"",$Col[$jc][$m]);
  }
  // elimination of the concerned position whatever the digit
  for($mc=0; $mc<=8; $mc++){
    // houses (the concerned house, number $n)
    $n = floor($i/3)*3+floor($j/3);
    $p = ($i-floor($i/3)*3)*3+($j-floor($j/3)*3);
    $posi = chr(48+$p);
    $Reg[$n][$mc] = str_replace($posi,"",$Reg[$n][$mc]);
    // rows
    $posi = chr(48+$j);
    $Lgn[$i][$mc] = str_replace($posi,"",$Lgn[$i][$mc]);
    // columns
    $posi = chr(48+$i);
    $Col[$j][$mc] = str_replace($posi,"",$Col[$j][$mc]);
  }
}
//
function affectation($i,$j,$m,$D){
  global $Grille ,$Masque ,$loterie ,$collision;
  if ($Grille[$i][$j]== "0"){
    $Grille[$i][$j]= chr(48+$m+1);
    $posi = chr(97+$i).chr(48+$j);
    $loterie = str_replace($posi,"",$loterie);
    elimination($i,$j,$m);
    if ($D== "1") $Masque[$i][$j]= 1;
  }
  else{
    $collision++;
  }
}
/*============================================================================*/
?>
